//
//  FilledPolygonTool.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Sat Feb 01 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

import java.awt.*;

public class FilledPolygonTool extends THSGeneralTool {

    paintbrush curbsh;
    boolean isDrawingPoly;
    Poly polygon;

    public FilledPolygonTool() {
        super();
        isDrawingPoly = false;
        curbsh = new squarebrush(1);
    }

    public String getIconImage() {
        return "painticon-1_fpoly.gif";
    }

    public String getCursorImage() {
        return "";
    }

    public String getString() {
        return "Filled Polygon";
    }

    public void mouseDown(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        if (!isDrawingPoly) { // First time
            isDrawingPoly = true;
            ((PaintCanvas) c).push();
            polygon = new Poly((PaintCanvas) c, true, mx, my);
        } else {
            if (this.checkDoubleClick(mx, my)) {
                isDrawingPoly = false;
                polygon.finishPoly(mx, my);
                ((PaintCanvas) c).recover();
                polygon.drawPoly((PaintCanvas) c, curbsh, mx, my);
                ((PaintCanvas) c).pop();
                return;
            }
            polygon.addPolyPoint(mx, my);
            polygon.drawPoly((PaintCanvas) c, curbsh, mx, my);
        }
    }

    public void mouseDrag(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        ((PaintCanvas) c).recover();
        polygon.drawPoly((PaintCanvas) c, curbsh, mx, my);
    }

    public void mouseMove(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        if (isDrawingPoly) {
            gi.setColor(((PaintCanvas) c).getFGColor());
            ((PaintCanvas) c).recover();
            polygon.drawPoly((PaintCanvas) c, curbsh, mx, my);
        }
    }

    public void mouseUp(int mx, int my, THSCanvas c) {
        Graphics gi = ((PaintCanvas) c).getGraphics();
        gi.setColor(((PaintCanvas) c).getFGColor());
        ((PaintCanvas) c).recover();
        polygon.drawPoly((PaintCanvas) c, curbsh, mx, my);
    }
    
    public boolean keyPressed(Event ke, int k, THSCanvas c) { return false; }
    public boolean keyUp(Event ke, int k, THSCanvas c) { return false; }
    public boolean keyDown(Event ke, int k, THSCanvas c) { return false; }

}
