//
//  Menubar.java
//  This is a generic Menubar class
//

import java.awt.*;
import java.applet.*;
import java.util.*;

import menuitems.*;
import hb;
import painthb;

public class Menubar extends hb {

    private Graphics gi;
    private int fsize = 12;
    private int menuPos;
    private int mheight;
    private int mwidth;
    
    static int space = 8; // spacing between each THMenu
    
    private FontMetrics fm;
    private Font menufont;

    /**
     * This instantiates the menu that is to be drawn in the specified Graphics object
     */
    public Menubar() {
        super("menubar", 0, 0, width, height, hb.MENUBAR);
        gi.setFont(menufont = new Font("Helvetica",Font.BOLD,fsize));
        fm = gi.getFontMetrics();

        menuPos = space;
    }
    
    /**
     * This draws the menus when the main application recognizes mouse activity
     */
    public void draw(Graphics gi)
    {
        gi.setColor(Color.white);
        gi.fillRect(0,0,mwidth,mheight);
        gi.setColor(Color.black);
        gi.drawLine(0,mheight,mwidth,mheight);

        gi.setFont(menufont);

        for (int i = 0; i < children.size(); i++) {
            ((THMenu) children.get(i)).draw(gi);
        }
    }

    /**
     * This method adds the THMenu to this menubar by first creating an instance of a THMenu and then
     * placing it properly with all the other Menus.  This method also returns the THMenu instantiated.
     **/
    public THMenu addMenu(String s) {
        int xw = 0;
        THMenu result = new THMenu(s, menuPos, 0, xw = (fm.stringWidth(s)+space*2), mheight);
        menuPos += xw;

        this.addChild(result);
        return result;
    }
    
    /**
     * This displays the menuitems when the main application recognizes mouse activity on the
     * particular menu specified in the arguments.
     */
    public THMenuItem dropMenu(hb m, int mx, int my)
    {
        int i;
        THMenuItem mitem =null;

        gi.setFont(menufont);
        
        // highlight menu
        gi.setColor(Color.black);
        m.fill(gi);
        gi.setColor(Color.white);
        m.placeString(gi);
        
        // unfold relevant menu

        THMenu currMenu = (THMenu) childrenht.get(m.cs);
        mitem = currMenu.unfold(gi);
        
        return mitem;
    }    
}
