//
//  Polygon.java
//  Treehousestudio
//
//  Created by Maxwell Planck on Wed Jan 22 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

import java.awt.*;
import java.util.*;

import paintbrush;

/**
 * This is a helpful drawing class that provides functionality for drawing the polygon stuff
 */
public class Poly {

    private Vector polyV;
    private boolean isDrawingFilledPoly;

    public Poly(PaintCanvas pc, boolean isdfp, int mx, int my) {
        isDrawingFilledPoly = isdfp;
        Graphics gi = pc.getGraphics();
        Simple.dot(gi,mx,my);
        polyV = new Vector();
        polyV.addElement(new Point(mx, my));
        
    }

    public void addPolyPoint(int mx, int my) {
        polyV.addElement(new Point(mx, my));
    }

    public void drawPoly(PaintCanvas pc, paintbrush curbsh, int mx, int my) {
        Graphics gi = pc.getGraphics();
        if ((isDrawingFilledPoly) && (polyV.size() > 2)) {
            gi.setColor(pc.getBGColor());
            try {
                fillPoly(gi, mx, my);
            } catch (RuntimeException re) {
                throw re;
            }
        }

        Point secondP = (Point) polyV.elementAt(0);
        Point lastP = (Point) polyV.elementAt(0);
        for (int i = 0; i < polyV.size()-1; i++) {
            Point firstP = (Point) polyV.elementAt(i);
            secondP = (Point) polyV.elementAt(i+1);
            gi.setColor(pc.getFGColor());
            Simple.line(gi, curbsh, firstP.x, firstP.y, secondP.x, secondP.y);
        }
        gi.setColor(pc.getFGColor());
        Simple.line(gi, curbsh, secondP.x, secondP.y, mx, my);
    }

    public void finishPoly(int mx, int my) {
        polyV.addElement(polyV.elementAt(0)); // create the loop
    }

    public void fillPoly(Graphics gi, int mx, int my) {
        int n = polyV.size();
        Point[] P = new Point[n+1];

        for (int i=0; i<n; i++) P[i] = (Point) polyV.elementAt(i);
        P[n] = new Point(mx, my);
        if (!ccw(P)) {
            for (int i=0; i<n; i++) P[i+1] = (Point) polyV.elementAt(n - i - 1);
            P[0] = new Point(mx, my);
            // If not counter-clockwise, reverse the order:
        }
        int ntr = n+1 - 2;
        Triangle[] tr = new Triangle[ntr];
        MathTools.triangulate(P, tr);
        for (int j=0; j<ntr; j++)
        {
            int[] x = new int[3], y = new int[3];
            x[0] = tr[j].A.x; y[0] = tr[j].A.y;
            x[1] = tr[j].B.x; y[1] = tr[j].B.y;
            x[2] = tr[j].C.x; y[2] = tr[j].C.y;
            gi.fillPolygon(x, y, 3);
        }
    }

    private boolean ccw(Point[] P)
    {  int n = P.length, k = 0;
        for (int i=1; i<n; i++)
            if (P[i].x <= P[k].x && (P[i].x < P[k].x || P[i].y < P[k].y))
                k = i;
        // P[k] is a convex vertex.
        int prev = k - 1, next = k + 1;
        if (prev == -1) prev = n - 1;
        if (next == n) next = 0;
        return MathTools.area2(P[prev], P[k], P[next]) > 0;
    }
}
